﻿using Infragistics.Win;
using Infragistics.Win.UltraWinEditors;
using Infragistics.Win.UltraWinToolbars;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ButtonToolBorderTest
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void ultraCheckEditor1_CheckedChanged(object sender, EventArgs e)
		{
			switch ((sender as UltraCheckEditor).Name)
			{
				case "ultraCheckEditor1":
				{
					ultraToolbarsManager1.Tools[0].SharedProps.Enabled = (sender as UltraCheckEditor).Checked;
				}
				break;

				case "ultraCheckEditor2":
				{
					ultraToolbarsManager1.Tools[1].SharedProps.Enabled = (sender as UltraCheckEditor).Checked;
				}
				break;

				case "ultraCheckEditor3":
				{
					ultraToolbarsManager1.Tools[2].SharedProps.Enabled = (sender as UltraCheckEditor).Checked;
				}
				break;
			}
		}

		private void Form1_Load(object sender, EventArgs e)
		{
			ultraToolbarsManager1.DrawFilter = new ButtonDrawFilter();
		}
	}

	internal class ButtonDrawFilter : IUIElementDrawFilter
	{
		public bool DrawElement(DrawPhase drawPhase, ref UIElementDrawParams drawParams)
		{
			var button = drawParams.Element.GetContext() as ButtonTool;
			if (button.EnabledResolved)
			{
				drawParams.DrawBorders(UIElementBorderStyle.Solid, Border3DSide.All);
				return true;
			}
			return false;
		}

		public DrawPhase GetPhasesToFilter(ref UIElementDrawParams drawParams)
		{
			if (drawParams.Element is ButtonToolUIElement)
			{
				return DrawPhase.BeforeDrawBorders;
			}

			return DrawPhase.None;
		}
	}
}
